#include <iostream>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

using namespace std;

int main(void)
{

  ////////////////////////////////////////////////////////////
  // Create a socket.
  ////////////////////////////////////////////////////////////
  int s = socket(PF_INET,SOCK_STREAM,0);

  if (s <= 0) {
    cerr << "server: Socket creation failed." << endl;
    exit(-1);
  }

  ////////////////////////////////////////////////////////////
  // Connect to server port
  ////////////////////////////////////////////////////////////
  sockaddr_in address;
  int addressSize = sizeof(sockaddr_in);
  address.sin_family=AF_INET;                         
  address.sin_port  = htons(15000); // <---------------- port 15000
  inet_pton(AF_INET,"127.0.0.1",&address.sin_addr);   // localhost

  int status=0;
  status = connect(s,(struct sockaddr*) &address, addressSize);

  if (status != 0) {
    cerr << "client:Connect operation failed, unable to connect to server port." << endl;
    cout << strerror(errno) << endl;
    exit(-1);
  }
  cout << "Established communication with server." << endl;

  ////////////////////////////////////////////////////////////
  // Get the number from the user
  ///////////////////////////////////////////////////////////
  long number = 0;
  cout << "Type in a number to find out if it's prime (0 quits): ";
  cin >> number;

  ////////////////////////////////////////////////////////////
  // Send number, a BIG INTEGER, to server
  ///////////////////////////////////////////////////////////
  send(s,&number,sizeof(long),0);
    
  ////////////////////////////////////////////////////////////
  // Receive response, a small boolean from server
  ///////////////////////////////////////////////////////////
  bool result = false;
  recv(s,&result,sizeof(bool),0);
  
  if (result) {
    cout << "PRIME" << endl;
  }
  else {
    cout << "NON-PRIME" << endl;
  }

  ////////////////////////////////////////////////////////////
  // Done! cleanup!
  ///////////////////////////////////////////////////////////
  cout << "Closing connection with server!" << endl;
  close(s);

  return 1;
}
